# CrewScheduling

## Introduction
This is a repository containing the code used for the article 'A Fast Exact Pricing Algorithm for the Railway Crew Scheduling Problem'. In this article, a new exact pricing algorithm is proposed, and this algorithm is compared to the fastest known exact algorithm from literature.

## Description
The code contains a framework that generates random instances of the crew scheduling problem and solves their LP-relaxation through column generation. The code contains implementations of the two pricing algorithms described in the article, as well as implementations of a cubic and quadratic algorithm for the pricing problem without meal break constraint.

## Requirements
A version of the commercial CPLEX is required, since this is used to solve linear programs. In the article, CPLEX 20.1.0 was used.

## Run
After adding a link to the CPLEX library through the Java Classpath, one can replicate the results of the article by running 'Main.java' in the 'scripts' folder. The results are then written to a local file 'results.csv'. 

One can extend this script by adding other, possibly custom, pricing algorithms, or modifying the number of tasks used in the instance generation. The problem parameters are stored in 'Parameters.java' in the 'instance' folder, and can be altered as well.
